﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.OleDb;
using System.Configuration;

namespace MyFriend.Common
{
    public class DBClass
    {
        public DBClass()
        {
            //
            // TODO: 在此处添加构造函数逻辑
            //
        }
        public static OleDbConnection GetConnection()
        {
            //string strconn = WebConfigurationManager.ConnectionStrings["StrCnn"].ToString();
            OleDbConnection odbc = new OleDbConnection(ConfigurationManager.AppSettings["sqlconn"]);

            return odbc;

        }
        public static void ExeSql(string strsql)
        {
            OleDbConnection con = GetConnection();
            con.Open();
            OleDbCommand cmd = new OleDbCommand(strsql, con);
            cmd.ExecuteNonQuery();
            cmd.Connection.Close();
            cmd.Dispose();
            con.Close();
            con.Dispose();
        }
        /// <summary>
        /// 执行sql，并获取对应的自增Id
        /// </summary>
        /// <param name="strsql"></param>
        /// <param name="strIdntitySql"></param>
        /// <returns></returns>
        public static int ExeSqlAndGetIdentity(string strsql, string strIdntitySql)
        {
            int IdentityId = 0;
            OleDbConnection con = GetConnection();
            con.Open();
            OleDbTransaction st = con.BeginTransaction();
            OleDbCommand cmd = con.CreateCommand();
            cmd.Transaction = st;
            try
            {
                cmd.CommandText = strsql;
                cmd.ExecuteNonQuery();
                st.Commit();
                IdentityId = Convert.ToInt32(ExeScaler(strIdntitySql));
            }
            catch (Exception ex)
            {
                st.Rollback();
            }
            return IdentityId;
        }
        public static void ExeSqlParas(string strsql, OleDbParameter[] paras)
        {
            OleDbConnection con = GetConnection();
            con.Open();
            OleDbCommand cmd = new OleDbCommand(strsql, con);
            foreach (OleDbParameter para in paras)
            {
                cmd.Parameters.Add(para);
            }
            cmd.ExecuteNonQuery();
        }

        public static void ExeSqlParas(string strsql, Dictionary<string, string> dics)
        {
            OleDbConnection con = GetConnection();
            con.Open();
            OleDbCommand cmd = new OleDbCommand(strsql, con);

            foreach (KeyValuePair<string, string> kv in dics)
            {
                OleDbParameter para = new OleDbParameter(kv.Key, DbType.String);
                para.Value = kv.Value;
                cmd.Parameters.Add(para);
            }
            cmd.ExecuteNonQuery();
        }
        /// <summary>
        /// 一次执行多条sql语句，成功返回1，否则返回0.
        /// </summary>
        /// <param name="strsql"></param>
        /// <returns></returns>
        public static int ExeSqlsWithTran(string[] strsql)
        {
            OleDbConnection con = GetConnection();
            con.Open();
            OleDbTransaction st = con.BeginTransaction();
            OleDbCommand cmd = con.CreateCommand();
            cmd.Transaction = st;
            try
            {
                foreach (string sql in strsql)
                {
                    cmd.CommandText = sql;
                    cmd.ExecuteNonQuery();
                }
                st.Commit();
                return 1;
            }
            catch
            {
                st.Rollback();
                return 0;
            }

        }
        public static string ExeScaler(string strsql)
        {
            OleDbConnection con = GetConnection();
            con.Open();
            OleDbCommand cmd = new OleDbCommand(strsql, con);
            string returnValue = cmd.ExecuteScalar().ToString();
            cmd.Connection.Close();
            cmd.Dispose();
            con.Close();
            con.Dispose();
            return returnValue;
        }

        public static string ExeScalerParas(string strsql, OleDbParameter[] paras)
        {
            OleDbConnection con = GetConnection();
            con.Open();
            OleDbCommand cmd = new OleDbCommand(strsql, con);
            foreach (OleDbParameter para in paras)
            {
                cmd.Parameters.Add(para);
            }
            string returnValue = cmd.ExecuteScalar().ToString();
            cmd.Connection.Close();
            cmd.Dispose();
            con.Close();
            con.Dispose();
            return returnValue;
        }

        public static DataSet GetDataSet(string strSql)
        {
            OleDbConnection con = GetConnection();
            con.Open();
            OleDbDataAdapter sda = new OleDbDataAdapter(strSql, con);
            DataSet ds = new DataSet();
            sda.Fill(ds);
            con.Close();
            con.Dispose();

            return ds;
        }

        public static DataTable GetTable(string strSql)
        {
            OleDbConnection con = GetConnection();
            con.Open();
            OleDbDataAdapter sda = new OleDbDataAdapter(strSql, con);
            DataTable dt = new DataTable();
            sda.Fill(dt);
            con.Close();
            con.Dispose();

            return dt;
        }

        public static DataTable PagerTable(string tableName, string columns, string where, string order, int pageSize, int CurrPage, ref string account)
        {
            string strsql = "select count(1) from " + tableName;
            if (where != "")
            {
                strsql += " WHERE " + where;
            }
            account = ExeScaler(strsql);

            strsql = "select " + columns + " from " + tableName;
            if (where != "")
            {
                strsql += " WHERE " + where;
            }
            if (order != "")
            {
                strsql += " order by " + order;
            }

            OleDbConnection con = GetConnection();
            con.Open();
            OleDbDataAdapter sda = new OleDbDataAdapter(strsql, con);
            DataSet ds = new DataSet();
            sda.Fill(ds, pageSize * (CurrPage - 1), pageSize, "t");
            return ds.Tables[0];
        }
    }
}
